/*
 * This file was generated by qdbusxml2cpp version 0.7
 * Command line was: qdbusxml2cpp -l Oscl::Qt::DBus::FreeDesktop::ObjectManager::Server -i server.h -i types.h -a adaptor dbus.xml
 *
 * qdbusxml2cpp is Copyright (C) 2015 The Qt Company Ltd.
 *
 * This was an auto-generated file.
 */

#ifndef ADAPTOR_H_1601566761
#define ADAPTOR_H_1601566761

#include <QtCore/QObject>
#include <QtDBus/QtDBus>
#include "contextapi.h"
#include "types.h"
class QByteArray;
template<class T> class QList;
template<class Key, class Value> class QMap;
class QString;
class QStringList;
class QVariant;

/** Adaptor class for interface org.freedesktop.DBus.ObjectManager
 */
class ObjectManagerAdaptor: public QDBusAbstractAdaptor
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.freedesktop.DBus.ObjectManager");
    Q_CLASSINFO("D-Bus Introspection", ""
		"  <interface name=\"org.freedesktop.DBus.ObjectManager\">\n"
		"    <method name=\"GetManagedObjects\">\n"
		"      <arg direction=\"out\" type=\"a{oa{sa{sv}}}\" name=\"object_paths_interfaces_and_properties\"/>\n"
		"      <annotation value=\"Oscl::Qt::DBus::FreeDesktop::ObjectManager::ManagedObjectList\" name=\"org.qtproject.QtDBus.QtTypeName.Out0\"/>\n"
		"    </method>\n"
		"    <signal name=\"InterfacesAdded\">\n"
		"      <arg type=\"o\" name=\"object_path\"/>\n"
		"      <arg type=\"a{sa{sv}}\" name=\"interfaces_and_properties\"/>\n"
		"      <annotation value=\"Oscl::Qt::DBus::FreeDesktop::ObjectManager::InterfaceList\" name=\"org.qtproject.QtDBus.QtTypeName.In1\"/>\n"
		"    </signal>\n"
		"    <signal name=\"InterfacesRemoved\">\n"
		"      <arg type=\"o\" name=\"object_path\"/>\n"
		"      <arg type=\"as\" name=\"interfaces\"/>\n"
		"    </signal>\n"
		"  </interface>\n"
        ""
		);

	private:
		/** */
		Oscl::Qt::DBus::FreeDesktop::ObjectManager::ContextApi&	_contextApi;

		/** */
		const QDBusConnection&	_bus;

	public:
		/** */
		ObjectManagerAdaptor(
			Oscl::Qt::DBus::FreeDesktop::
			ObjectManager::ContextApi&		contextApi,
			const QDBusConnection&			bus,
			QObject*						parent
			);

		/** */
		virtual ~ObjectManagerAdaptor();

	public: // PROPERTIES

	public Q_SLOTS: // METHODS
		/** */
		Oscl::Qt::DBus::FreeDesktop::ObjectManager::ManagedObjectList
		GetManagedObjects(const QDBusMessage& message);

	Q_SIGNALS: // SIGNALS
		/** */
		void InterfacesAdded(
				const QDBusObjectPath&			object_path,
				Oscl::Qt::DBus::FreeDesktop::
				ObjectManager::InterfaceList	interfaces_and_properties
				);

		/** */
		void InterfacesRemoved(
				const QDBusObjectPath&	object_path,
				const QStringList&		interfaces
				);
};

#endif
